#ifndef KANJI_UNION_H
#define KANJI_UNION_H

#ifdef __BORLANDC__
#pragma warn -8004
#pragma warn -8012
#endif

#define VERSION 1.07
#define BELL 0x07
#define BELL_ASCII_KATAKANA_COUNT 224
#define BLOCK_SIZE 2560
#define BUFFER_SIZE 524288 /* 512 KB */
#define CARRIAGE_RETURN_LINE_FEED "-CRLF"
#define C_SIZE 256 // FILE_NAME_SIZE + 1
#define C_SJIS_UTF8_BIN "C:\\sjisUTF8-C\\MS932~UTF-8.bin"
#define DO_NOT_REMOVE_TEMPORARY_BINARY_FILE "-y"
#define DO_NOT_SEARCH_TABLE "-d"
#define DOUBLE_KANJI 5 /* SJIS_KANJI_SIZE + UTF8_KANJI_SIZE */
#define ERROR_TEXT "error.txt"
#define FILE_NAME_SIZE 255
#define FILE_ERROR_CODE -2
#define FIRST_KANJI 159
#define IDENTICAL_TIME "-t"
#define KANA_HANDAKUTEN 0xDF
#define KANA_KUTEN 0xA1
#define KANJI_SIZE 2
#define LINE_FEED "-LF"
#define RECORD_COUNT 7882
#define SEARCH_COUNT 4
#define SJIS_KANJI_SIZE 2
#define SJIS_UTF8_BIN "MS932~UTF-8.bin"
#define SJIS_UTF8_TEXT "sjisUTF8.txt"
#define SKIPPING "-s"
#define TEMPORARY_BINARY "binary.tmp"
#define TEMPORARY_BINARY_FILE "-b"
#define UTF8_KANJI_SIZE 3
#define UTF8_KANJI_SIZE_1 4
#define WHICH_TABLE "-w"
#define ZERO "0"
#include "dividing.h"

typedef BOOL (*OPEN_CLOSE_FUNCTION)(char *buffer, int buffer_size);

typedef union KANJI KANJI;
union KANJI {
    unsigned char sequence[6];
    unsigned short code[3];
    unsigned int block;
};

typedef struct REGULATE REGULATE;
struct REGULATE {
    BOOL no_searching, which_table;
    char *buffer;
    char *combo;
    char document_name[ FILE_NAME_SIZE + 1 ];
};

typedef struct UTF8_TABLE UTF8_TABLE;
struct UTF8_TABLE {
    char binary_name[ FILE_NAME_SIZE + 1 ];
    char combo[4];
    char *table;
    int size;
};

BOOL allocating(REGULATE *r, char *d, BOOL n, BOOL w);
BOOL open_close(char *file_name);
BOOL setting(UTF8_TABLE *u, BOOL no_searching, BOOL *which_table);
BOOL sjis_utf8_file_in_current_directory(char *buffer, int buffer_size);
BOOL sjis_utf8_file_in_installed_directory(char *buffer, int buffer_size);
BOOL sjis_utf8_file_in_path_directory(char *buffer, int buffer_size);
BOOL sjis_utf8_file_in_specified_directory(char *buffer, int buffer_size);
char *growing(UTF8_TABLE *u, int index);
int inverted(char *c);
int produce_temporary_binary_file(const char *name, BOOL no_removing);
int reading_to_produce_UTF8(REGULATE *r, char *new_name);
int reading_to_produce_UTF8_CRLF(REGULATE *r, char *new_name);
int rename_binary_file(const char *name, BOOL no_removing);
int skipping_control_characters_to_produce_UTF8(REGULATE *r, char *new_name);
int skipping_control_characters_to_produce_UTF8_CRLF(REGULATE *r, char *new_name);
int standard_input_output(REGULATE *r);
int standard_input_output_skipping(REGULATE *r);
unsigned char working(UTF8_TABLE *u, int index, int place);
void acquire_parameters_from_text(const char *parameters_text, char *binary_name, char *document_name, char *new_name, BOOL *produce_binary_file, BOOL *carriage_return, BOOL *no_searching, BOOL *skip_control_characters, BOOL *identical_time, BOOL *which_table, BOOL *no_removing);
void clear_table(UTF8_TABLE *u);
void detach_table(UTF8_TABLE *u);
void error_handler(const char *p, const char *q);
void path_name(char *data, char *extra, char *buffer, int buffer_size);
void populated(UTF8_TABLE *u, int index, int place, char c);
void release_buffers(REGULATE *r);
void version_guide(double v, BOOL comments);

#endif /* KANJI_UNION_H */
