#ifndef LEAF_H
#define LEAF_H

#define EDIT_FUNCTION_FACTOR 2
#define FIELD_COUNT 3072
#define STEM 0
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "bool_true.h"

typedef char* FIELD_POINTER;
typedef FIELD_POINTER (*EDIT_FUNCTION)(FIELD_POINTER p);

typedef struct LEAF LEAF;
struct LEAF {
    char *leaf;
    int leaf_number;
    LEAF *left;
    LEAF *right;
};

int creep(LEAF *beginning, char *p, BOOL reverse);
LEAF *sprout(LEAF *left, char *p);
void leafy_tree(LEAF *beginning, char *buffer, int separator);
void linked_list_to_array_arranging_in_reverse_order(LEAF *beginning);
void linked_list_to_array_complementing(LEAF *beginning, char *extra, int bond, int buffer_size);
void linked_list_to_array_editing(LEAF *beginning, EDIT_FUNCTION editing, int field_number, int buffer_size);
void linked_list_to_array_mapping(LEAF *beginning);
void lose_leaves(LEAF *right);

#endif /* LEAF_H */
